module.exports = function cors(){
  return function(req, res, next) {
    var oneof = false;

    // CORS middleware
    // https://gist.github.com/3983284

    // @todo currently: "freifahrtschein" for all requests...
    // https://developer.mozilla.org/en-US/docs/HTTP/Access_control_CORS#Access-Control-Allow-Origin

    if(req.headers.origin) {
      res.setHeader('Access-Control-Allow-Origin', req.headers.origin);
      oneof = true;
    }
    if(req.headers['access-control-request-method']) {
      res.setHeader('Access-Control-Allow-Methods', req.headers['access-control-request-method']);
      oneof = true;
    }
    if(req.headers['access-control-request-headers']) {
      res.setHeader('Access-Control-Allow-Headers', req.headers['access-control-request-headers']);
      oneof = true;
    }
    if(oneof) {
      res.setHeader('Access-Control-Max-Age', 60 * 60 * 24 * 365);
    }

    // intercept OPTIONS method
    if (oneof && req.method == 'OPTIONS') {
      res.send(200);
    }
    else {
      next();
    }    
  };
};